//#include "mbed.h"
//#include "config.h"
#include "uart.h"

#define AHBMEM 			((void *)(0x2007C000 + 0x1D0))		// 先頭の0x1D0バイトはusbhost_lpc17xx.cで使う
#define AHBMEMSIZE 		(16300 * 2 - 0x1D0)		//
//#define AHBMEM ((void *)0x2007C000)
//#define AHBMEMSIZE (16300 * 2)		// ethernetの領域も使う
//#define AHBMEM ((void *)0x20080000)
//#define AHBMEMSIZE 16300

#define AHB0MEM 		((void *)0x2007C000)
#define AHB0MEMSIZE		0x2000

#define AHB1MEM 		((void *)0x20080000)
#define AHB1MEMSIZE		0x4000

static char *free_ptr = (char *)AHBMEM;
static int free_sz = AHBMEMSIZE;

static char *free_ptr_ahb0 = (char *)AHB0MEM;
static int free_sz_ahb0 = AHB0MEMSIZE;

static char *free_ptr_ahb1 = (char *)AHB1MEM;
static int free_sz_ahb1 = AHB1MEMSIZE;

void reset_ahb_mem(void)
{
   free_ptr = (char *)AHBMEM;
   free_sz = AHBMEMSIZE;
}

void *mad_malloc(unsigned int sz)
{
  unsigned int nsz = ((sz >> 3) + 1) << 3; // align to 8 byte
  if(nsz < free_sz)
  {
    char *p = free_ptr;
	free_ptr += nsz;
	free_sz -=nsz;
	//UARTSendInt(1, "free_sz=", 8, free_sz);
	return(p);
  }
  else
  {
	  DebugWriteln("no mem\r\n");
	  return (void *)0;
	  //return(malloc(sz));
  }
}

// 9/23
// AHB SRAM - bank 0 から取得する
void *mad_malloc_ahb0(unsigned int sz)
{
  unsigned int nsz = ((sz >> 3) + 1) << 3; // align to 8 byte
  if(nsz < free_sz_ahb0)
  {
    char *p = free_ptr_ahb0;
	free_ptr_ahb0 += nsz;
	free_sz_ahb0 -=nsz;
	//UARTSendInt(1, "free_sz_ahb0=", 8, free_sz_ahb0);
	return(p);
  }
  else
  {
	  DebugWriteln("no mem ahb0 \r\n");
	  return (void *)0;
	  //return(malloc(sz));
  }
}

// AHB SRAM - bank 1 から取得する
void *mad_malloc_ahb1(unsigned int sz)
{
  unsigned int nsz = ((sz >> 3) + 1) << 3; // align to 8 byte
  if(nsz < free_sz_ahb1)
  {
    char *p = free_ptr_ahb1;
	free_ptr_ahb1 += nsz;
	free_sz_ahb1 -=nsz;
	//UARTSendInt(1, "free_sz_ahb1=", 8, free_sz_ahb1);
	return(p);
  }
  else
  {
	  DebugWriteln("no mem ahb1 \r\n");
	  return (void *)0;
	  //return(malloc(sz));
  }
}
